Create setup intent
curl --request POST \
--url https://api.natural.com/setup-intents \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"data": {
"attributes": {
"terms": {
"description": "Damage deposit for your stay",
"amountType": "variable",
"amount": 50000,
"usage": "multiUse",
"validUntil": "2026-11-23T00:00:00Z"
},
"expiresAt": "2026-10-30T00:00:00Z"
}
}
}
'import requests
url = "https://api.natural.com/setup-intents"
payload = { "data": { "attributes": {
"terms": {
"description": "Damage deposit for your stay",
"amountType": "variable",
"amount": 50000,
"usage": "multiUse",
"validUntil": "2026-11-23T00:00:00Z"
},
"expiresAt": "2026-10-30T00:00:00Z"
} } }
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
data: {
attributes: {
terms: {
description: 'Damage deposit for your stay',
amountType: 'variable',
amount: 50000,
usage: 'multiUse',
validUntil: '2026-11-23T00:00:00Z'
},
expiresAt: '2026-10-30T00:00:00Z'
}
}
})
};
fetch('https://api.natural.com/setup-intents', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.natural.com/setup-intents",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'attributes' => [
'terms' => [
'description' => 'Damage deposit for your stay',
'amountType' => 'variable',
'amount' => 50000,
'usage' => 'multiUse',
'validUntil' => '2026-11-23T00:00:00Z'
],
'expiresAt' => '2026-10-30T00:00:00Z'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.natural.com/setup-intents"
payload := strings.NewReader("{\n \"data\": {\n \"attributes\": {\n \"terms\": {\n \"description\": \"Damage deposit for your stay\",\n \"amountType\": \"variable\",\n \"amount\": 50000,\n \"usage\": \"multiUse\",\n \"validUntil\": \"2026-11-23T00:00:00Z\"\n },\n \"expiresAt\": \"2026-10-30T00:00:00Z\"\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.natural.com/setup-intents")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"data\": {\n \"attributes\": {\n \"terms\": {\n \"description\": \"Damage deposit for your stay\",\n \"amountType\": \"variable\",\n \"amount\": 50000,\n \"usage\": \"multiUse\",\n \"validUntil\": \"2026-11-23T00:00:00Z\"\n },\n \"expiresAt\": \"2026-10-30T00:00:00Z\"\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.natural.com/setup-intents")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"data\": {\n \"attributes\": {\n \"terms\": {\n \"description\": \"Damage deposit for your stay\",\n \"amountType\": \"variable\",\n \"amount\": 50000,\n \"usage\": \"multiUse\",\n \"validUntil\": \"2026-11-23T00:00:00Z\"\n },\n \"expiresAt\": \"2026-10-30T00:00:00Z\"\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"id": "set_019d0a1b2c3d4e5f60718293a4b5c6e1",
"type": "setupIntent",
"attributes": {
"status": "open",
"setupUrl": "https://checkout.natural.com/#k7q2m9x4b8n1v6c3",
"clientSecret": "set_019d0a1b2c3d4e5f60718293a4b5c6e1_secret_live_tcTy4NoQJkF6ShQTh5Y8ubLmbQikz5K9JBobGtauWws",
"lastFailure": null,
"expiresAt": "2026-10-30T00:00:00Z",
"canceledAt": null,
"createdAt": "2026-10-27T15:00:00Z",
"updatedAt": "2026-10-27T15:00:00Z"
},
"relationships": {
"mandate": {
"data": null
}
}
}
}Setup intents
Create setup intent
Create a link where a guest saves a card under an agreement, with no charge now. Returns the Setup Intent object.
POST
/
setup-intents
Create setup intent
curl --request POST \
--url https://api.natural.com/setup-intents \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'Idempotency-Key: <idempotency-key>' \
--data '
{
"data": {
"attributes": {
"terms": {
"description": "Damage deposit for your stay",
"amountType": "variable",
"amount": 50000,
"usage": "multiUse",
"validUntil": "2026-11-23T00:00:00Z"
},
"expiresAt": "2026-10-30T00:00:00Z"
}
}
}
'import requests
url = "https://api.natural.com/setup-intents"
payload = { "data": { "attributes": {
"terms": {
"description": "Damage deposit for your stay",
"amountType": "variable",
"amount": 50000,
"usage": "multiUse",
"validUntil": "2026-11-23T00:00:00Z"
},
"expiresAt": "2026-10-30T00:00:00Z"
} } }
headers = {
"Idempotency-Key": "<idempotency-key>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'Idempotency-Key': '<idempotency-key>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
data: {
attributes: {
terms: {
description: 'Damage deposit for your stay',
amountType: 'variable',
amount: 50000,
usage: 'multiUse',
validUntil: '2026-11-23T00:00:00Z'
},
expiresAt: '2026-10-30T00:00:00Z'
}
}
})
};
fetch('https://api.natural.com/setup-intents', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.natural.com/setup-intents",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'data' => [
'attributes' => [
'terms' => [
'description' => 'Damage deposit for your stay',
'amountType' => 'variable',
'amount' => 50000,
'usage' => 'multiUse',
'validUntil' => '2026-11-23T00:00:00Z'
],
'expiresAt' => '2026-10-30T00:00:00Z'
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json",
"Idempotency-Key: <idempotency-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.natural.com/setup-intents"
payload := strings.NewReader("{\n \"data\": {\n \"attributes\": {\n \"terms\": {\n \"description\": \"Damage deposit for your stay\",\n \"amountType\": \"variable\",\n \"amount\": 50000,\n \"usage\": \"multiUse\",\n \"validUntil\": \"2026-11-23T00:00:00Z\"\n },\n \"expiresAt\": \"2026-10-30T00:00:00Z\"\n }\n }\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Idempotency-Key", "<idempotency-key>")
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.natural.com/setup-intents")
.header("Idempotency-Key", "<idempotency-key>")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"data\": {\n \"attributes\": {\n \"terms\": {\n \"description\": \"Damage deposit for your stay\",\n \"amountType\": \"variable\",\n \"amount\": 50000,\n \"usage\": \"multiUse\",\n \"validUntil\": \"2026-11-23T00:00:00Z\"\n },\n \"expiresAt\": \"2026-10-30T00:00:00Z\"\n }\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.natural.com/setup-intents")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Idempotency-Key"] = '<idempotency-key>'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"data\": {\n \"attributes\": {\n \"terms\": {\n \"description\": \"Damage deposit for your stay\",\n \"amountType\": \"variable\",\n \"amount\": 50000,\n \"usage\": \"multiUse\",\n \"validUntil\": \"2026-11-23T00:00:00Z\"\n },\n \"expiresAt\": \"2026-10-30T00:00:00Z\"\n }\n }\n}"
response = http.request(request)
puts response.read_body{
"data": {
"id": "set_019d0a1b2c3d4e5f60718293a4b5c6e1",
"type": "setupIntent",
"attributes": {
"status": "open",
"setupUrl": "https://checkout.natural.com/#k7q2m9x4b8n1v6c3",
"clientSecret": "set_019d0a1b2c3d4e5f60718293a4b5c6e1_secret_live_tcTy4NoQJkF6ShQTh5Y8ubLmbQikz5K9JBobGtauWws",
"lastFailure": null,
"expiresAt": "2026-10-30T00:00:00Z",
"canceledAt": null,
"createdAt": "2026-10-27T15:00:00Z",
"updatedAt": "2026-10-27T15:00:00Z"
},
"relationships": {
"mandate": {
"data": null
}
}
}
}Authorizations
Headers
Was this page helpful?